Index: trunk/language/en_UK.iso-8859-1/admin.lang.php
===================================================================
--- trunk/language/en_UK.iso-8859-1/admin.lang.php	(revision 1044)
+++ trunk/language/en_UK.iso-8859-1/admin.lang.php	(revision 1045)
@@ -45,4 +45,5 @@
 $lang['Add selected elements to caddie'] = 'Add selected elements to caddie';
 $lang['Add'] = 'Add';
+$lang['Are you sure?'] = 'Are you sure?';
 $lang['Associated'] = 'Associated';
 $lang['Association to categories'] = 'Association to categories';
Index: trunk/language/fr_FR.iso-8859-1/admin.lang.php
===================================================================
--- trunk/language/fr_FR.iso-8859-1/admin.lang.php	(revision 1044)
+++ trunk/language/fr_FR.iso-8859-1/admin.lang.php	(revision 1045)
@@ -45,4 +45,5 @@
 $lang['Add selected elements to caddie'] = 'Ajouter les éléments sélectionnés au panier';
 $lang['Add'] = 'Ajouter';
+$lang['Are you sure?'] = 'Etes-vous sur?';
 $lang['Associated'] = 'Associée à';
 $lang['Association to categories'] = 'Association aux catégories';
Index: trunk/template/yoga/admin/cat_list.tpl
===================================================================
--- trunk/template/yoga/admin/cat_list.tpl	(revision 1044)
+++ trunk/template/yoga/admin/cat_list.tpl	(revision 1045)
@@ -22,5 +22,5 @@
         <!-- END permissions -->
         <!-- BEGIN delete -->
-        <li><a href="{category.delete.URL}" title="{lang:delete category}"><img src="{themeconf:icon_dir}/category_delete.png" class="button" alt="{lang:delete}" /></a></li>
+        <li><a href="{category.delete.URL}" title="{lang:delete category}" onclick="return confirm('{lang:Are you sure?}');"><img src="{themeconf:icon_dir}/category_delete.png" class="button" alt="{lang:delete}" /></a></li>
         <!-- END delete -->
       </ul>
Index: trunk/template/yoga/admin/cat_modify.tpl
===================================================================
--- trunk/template/yoga/admin/cat_modify.tpl	(revision 1044)
+++ trunk/template/yoga/admin/cat_modify.tpl	(revision 1045)
@@ -19,5 +19,5 @@
   <!-- END permissions -->
   <!-- BEGIN delete -->
-  <li><a href="{delete.URL}" title="{lang:delete category}"><img src="{themeconf:icon_dir}/category_delete.png" class="button" alt="{lang:delete}" /></a></li>
+  <li><a href="{delete.URL}" title="{lang:delete category}" onclick="return confirm('{lang:Are you sure?}');"><img src="{themeconf:icon_dir}/category_delete.png" class="button" alt="{lang:delete}" /></a></li>
   <!-- END delete -->
 </ul>
Index: trunk/template/yoga/admin/group_list.tpl
===================================================================
--- trunk/template/yoga/admin/group_list.tpl	(revision 1044)
+++ trunk/template/yoga/admin/group_list.tpl	(revision 1045)
@@ -22,5 +22,5 @@
     <td style="text-align:center;">
       <a href="{group.U_PERM}"><img src="{themeconf:icon_dir}/permissions.png" class="button" style="border:none" alt="permissions" title="{lang:permissions}" /></a>
-      <a href="{group.U_DELETE}"><img src="{themeconf:icon_dir}/delete.png" class="button" style="border:none" alt="delete" title="{lang:delete}" /></a>
+      <a href="{group.U_DELETE}" onclick="return confirm('{lang:Are you sure?}');"><img src="{themeconf:icon_dir}/delete.png" class="button" style="border:none" alt="delete" title="{lang:delete}" /></a>
     </td>
   </tr>
Index: trunk/template/yoga/admin/site_manager.tpl
===================================================================
--- trunk/template/yoga/admin/site_manager.tpl	(revision 1044)
+++ trunk/template/yoga/admin/site_manager.tpl	(revision 1045)
@@ -25,5 +25,5 @@
     [<a href="{sites.site.U_UPDATE}" title="{lang:update this site}">{lang:remote_site_update}</a>]
     <!-- BEGIN delete -->
-      [<a href="{sites.site.delete.U_DELETE}" onclick="return confirm('{lang:remote_site_delete_hint}.\n{sites.site.NAME}\n{lang:Are you sure}?');" 
+      [<a href="{sites.site.delete.U_DELETE}" onclick="return confirm('{lang:Are you sure?}');" 
                 title="{lang:remote_site_delete_hint}">{lang:remote_site_delete}</a>]
     <!-- END delete -->