Index: trunk/template/yoga/admin.tpl
===================================================================
--- trunk/template/yoga/admin.tpl	(revision 1118)
+++ trunk/template/yoga/admin.tpl	(revision 1119)
@@ -55,4 +55,5 @@
 	<li><a href="{U_RATING}">{lang:Rating}</a></li>
 	<li><a href="{U_CADDIE}">{lang:Caddie}</a></li>
+	<li><a href="{U_TAGS}">{lang:Tags}</a></li>
       </ul>
     </dd>
Index: trunk/template/yoga/admin/element_set_global.tpl
===================================================================
--- trunk/template/yoga/admin/element_set_global.tpl	(revision 1118)
+++ trunk/template/yoga/admin/element_set_global.tpl	(revision 1119)
@@ -84,19 +84,13 @@
 
     <tr>
-      <td>{lang:add keywords}</td>
-      <td><input type="text" name="add_keywords" value="" /></td>
+      <td>{lang:add tags}</td>
+      <td>{ADD_TAG_SELECTION}</td>
     </tr>
 
     <tr>
-      <td>{lang:remove keyword}</td>
-      <td>
-        <select name="remove_keyword">
-          <!-- BEGIN remove_keyword_option -->
-          <option value="{remove_keyword_option.VALUE}">{remove_keyword_option.OPTION}</option>
-          <!-- END remove_keyword_option -->
-        </select>
-      </td>
+      <td>{lang:remove tags}</td>
+      <td>{DEL_TAG_SELECTION}</td>
     </tr>
-
+    
     <tr>
       <td>{lang:author}</td>
Index: trunk/template/yoga/admin/element_set_unit.tpl
===================================================================
--- trunk/template/yoga/admin/element_set_unit.tpl	(revision 1118)
+++ trunk/template/yoga/admin/element_set_unit.tpl	(revision 1119)
@@ -70,6 +70,6 @@
 
     <tr>
-      <td><strong>{lang:Keywords}</strong></td>
-      <td><input type="text" name="keywords-{element.ID}" value="{element.KEYWORDS}" size="50" /></td>
+      <td><strong>{lang:Tags}</strong></td>
+      <td>{element.TAG_SELECTION}</td>
     </tr>
 
Index: trunk/template/yoga/admin/picture_modify.tpl
===================================================================
--- trunk/template/yoga/admin/picture_modify.tpl	(revision 1118)
+++ trunk/template/yoga/admin/picture_modify.tpl	(revision 1119)
@@ -100,8 +100,9 @@
 
       <tr>
-        <td><strong>{lang:Keywords}</strong></td>
-        <td><input type="text" name="keywords" value="{KEYWORDS}" size="50" /></td>
+        <td><strong>{lang:Tags}</strong></td>
+        <td>{TAG_SELECTION}</td>
       </tr>
 
+      
       <tr>
         <td><strong>{lang:Description}</strong></td>
Index: trunk/template/yoga/admin/tags.tpl
===================================================================
--- trunk/template/yoga/admin/tags.tpl	(revision 1119)
+++ trunk/template/yoga/admin/tags.tpl	(revision 1119)
@@ -0,0 +1,55 @@
+<div class="titrePage">
+  <h2>{lang:Manage tags}</h2>
+</div>
+
+<form action="{F_ACTION}" method="post">
+
+  <!-- BEGIN edit_tags -->
+  <input type="hidden" name="edit_list" value="{edit_tags.LIST}" />
+
+  <fieldset>
+    <legend>{lang:Edit tags}</legend>
+
+    <table class="table2">
+      <tr class="throw">
+        <th>{lang:Current name}</th>
+        <th>{lang:New name}</th>
+      </tr>
+      <!-- BEGIN tag -->
+      <tr>
+        <td>{edit_tags.tag.NAME}</td>
+        <td><input type="text" name="tag_name-{edit_tags.tag.ID}" value="{edit_tags.tag.NAME}" /></td>
+      </tr>
+      <!-- END tag -->
+    </table>
+
+    <p>
+      <input type="submit" name="submit" value="{lang:Submit}" {TAG_INPUT_ENABLED} />
+      <input type="reset" value="{lang:Reset}" />
+    </p>
+  </fieldset>
+  <!-- END edit_tags -->
+
+  <fieldset>
+    <legend>{lang:Add a tag}</legend>
+
+    <label>
+      {lang:New tag}
+      <input type="text" name="add_tag" />
+    </label>
+    
+    <p><input type="submit" name="add" value="{lang:Submit}" {TAG_INPUT_ENABLED}/></p>
+  </fieldset>
+
+  <fieldset>
+    <legend>{lang:Tag selection}</legend>
+    
+    {TAG_SELECTION}
+
+    <p>
+      <input type="submit" name="edit" value="{lang:Edit selected tags}" {TAG_INPUT_ENABLED}/>
+      <input type="submit" name="delete" value="{lang:Delete selected tags}" {TAG_INPUT_ENABLED}/>
+    </p>
+  </fieldset>
+
+</form>
Index: trunk/template/yoga/content.css
===================================================================
--- trunk/template/yoga/content.css	(revision 1118)
+++ trunk/template/yoga/content.css	(revision 1119)
@@ -14,4 +14,5 @@
 BODY#thePasswordPage #content,
 BODY#theNotificationPage #content,
+BODY#theTagsPage #content,
 BODY#theNBMPage #content
 {
Index: trunk/template/yoga/default-layout.css
===================================================================
--- trunk/template/yoga/default-layout.css	(revision 1118)
+++ trunk/template/yoga/default-layout.css	(revision 1119)
@@ -262,2 +262,11 @@
 }
 
+UL.tagSelection {
+  width: 500px;
+  padding: 0;
+}
+
+UL.tagSelection LI {
+  display: inline;
+  white-space: nowrap;
+}
Index: trunk/template/yoga/index.tpl
===================================================================
--- trunk/template/yoga/index.tpl	(revision 1118)
+++ trunk/template/yoga/index.tpl	(revision 1119)
@@ -20,4 +20,21 @@
   </dd>
 </dl>
+
+<!-- BEGIN tags -->
+<dl>
+  <dt>{lang:Related tags}</dt>
+  <dd>
+    <ul id="menuTagCloud">
+      <!-- BEGIN tag -->
+      <li>
+        <a href="{tags.tag.URL_ADD}" title="{tags.tag.TITLE_ADD}"><img src="{pwg_root}{themeconf:icon_dir}/add_tag.png" alt="+"></a>
+        <a href="{tags.tag.URL}" class="{tags.tag.CLASS}" title="{tags.tag.TITLE}">{tags.tag.NAME}</a>
+      </li>
+      <!-- END tag -->
+    </ul>
+  </dd>
+</dl>
+<!-- END tags -->
+
 <dl>
   <dt>{lang:special_categories}</dt>
Index: trunk/template/yoga/menubar.css
===================================================================
--- trunk/template/yoga/menubar.css	(revision 1118)
+++ trunk/template/yoga/menubar.css	(revision 1119)
@@ -96,2 +96,11 @@
 }
 
+#menubar #menuTagCloud {
+  text-align: center;
+  margin: 5px 0;
+}
+
+#menubar #menuTagCloud LI
+{
+  display: inline;
+}
Index: trunk/template/yoga/picture.tpl
===================================================================
--- trunk/template/yoga/picture.tpl	(revision 1118)
+++ trunk/template/yoga/picture.tpl	(revision 1119)
@@ -108,6 +108,6 @@
   </tr>
   <tr>
-    <td class="label">{lang:Keywords}</td>
-    <td class="value">{INFO_KEYWORDS}</td>
+    <td class="label">{lang:Tags}</td>
+    <td class="value">{INFO_TAGS}</td>
   </tr>
   <tr>
Index: trunk/template/yoga/search.tpl
===================================================================
--- trunk/template/yoga/search.tpl	(revision 1118)
+++ trunk/template/yoga/search.tpl	(revision 1119)
@@ -36,4 +36,14 @@
 	</td>
   </tr>
+  
+  <tr>
+    <td colspan="2"><b>{lang:Search tags} :</b></td>
+    <td colspan="2" valign="middle">
+      {TAG_SELECTION}
+      <br /><label><input type="radio" name="tag_mode" value="AND" checked="checked" /> {lang:All tags}</label>
+      <br /><label><input type="radio" name="tag_mode" value="OR" /> {lang:Any tag}</label>
+    </td>
+  </tr>
+  
   <tr>
     <td colspan="2"><b>{L_SEARCH_DATE} :</b>
Index: trunk/template/yoga/search_rules.tpl
===================================================================
--- trunk/template/yoga/search_rules.tpl	(revision 1118)
+++ trunk/template/yoga/search_rules.tpl	(revision 1119)
@@ -10,4 +10,16 @@
   <!-- END words -->
 
+  <!-- BEGIN tags -->
+  <li>
+    <p>{tags.LIST_INTRO}</p>
+
+    <ul>
+      <!-- BEGIN tag -->
+      <li>{tags.tag.NAME}</li>
+      <!-- END tag -->
+    </ul>
+  </li>
+  <!-- END tags -->
+  
   <!-- BEGIN author -->
   <li>{author.CONTENT}</li>
Index: trunk/template/yoga/tags.tpl
===================================================================
--- trunk/template/yoga/tags.tpl	(revision 1119)
+++ trunk/template/yoga/tags.tpl	(revision 1119)
@@ -0,0 +1,17 @@
+<!-- $Id: comments.tpl 960 2005-12-03 17:33:38Z chrisaga $ -->
+<div id="content">
+
+  <div class="titrePage">
+    <ul class="categoryActions">
+      <li><a href="{U_HOME}" title="{lang:return to homepage}"><img src="{themeconf:icon_dir}/home.png" class="button" alt="{lang:home}"/></a></li>
+    </ul>
+    <h2>{lang:Tags}</h2>
+  </div>
+
+  <ul id="fullTagCloud">
+    <!-- BEGIN tag -->
+    <li><a href="{tag.URL}" class="{tag.CLASS}" title="{tag.TITLE}">{tag.NAME}</a></li>
+    <!-- END tag -->
+  </ul>
+
+</div> <!-- content -->